package com.zipcodewilmington;

import com.sun.deploy.util.ArrayUtil;

import java.util.Arrays;
import java.util.Collections;

/**
 * Created by leon on 1/29/18.
 */
public class StringArrayUtils {
    /**
     * @param array array of String objects
     * @return first element of specified array
     */ // TODO
    public static String getFirstElement(String[] array) {
        return array[0];
    }

    /**
     * @param array array of String objects
     * @return second element in specified array
     */
    public static String getSecondElement(String[] array) {

        return array[1];
    }

    /**
     * @param array array of String objects
     * @return last element in specified array
     */ // TODO
    public static String getLastElement(String[] array) {

        return array[array.length-1];
    }

    /**
     * @param array array of String objects
     * @return second to last element in specified array
     */ // TODO
    public static String getSecondToLastElement(String[] array) {

        return array[array.length-2];
    }

    /**
     * @param array array of String objects
     * @param value value to check array for
     * @return true if the array contains the specified `value`
     */ // TODO
    public static boolean contains(String[] array, String value) {
        for( String n : array){
            if (value == n){
                return true;
            }
        }
            return false;
    }

    /**
     * @param array of String objects
     * @return an array with identical contents in reverse order
     */ // TODO
    public static String[] reverse(String[] array) {
        String [] b = new String[array.length];
        for(int i=0; i< array.length; i++){
            b[i] = array[array.length-1-i];
        }
        return b;
    }

    /**
     * @param array array of String objects
     * @return true if the order of the array is the same backwards and forwards
     */ // TODO
    public static boolean isPalindromic(String[] array) {
        for( int i=0; i<array.length;i++) {
            if (array[i].equals(array[array.length-1-i])) {
                return true;
            }
        }
        return false;
    }

    /**
     * @param array array of String objects
     * @return true if each letter in the alphabet has been used in the array
     */ // TODO
    public static boolean isPangramic(String[] array) {
        String str = String.join(",",array);
        char[] charArray = str.toCharArray();
        char[] arr = new char[26];
        int index = 0;
        for (char c = 'a';c <= 'z'; c++) {
            arr[index++] = c;
            if (charArray.length > 26){
                return true;
            }
        }

                return false;
    }

    /**
     * @param array array of String objects
     * @param value value to check array for
     * @return number of occurrences the specified `value` has occurred
     */ // TODO
    public static int getNumberOfOccurrences(String[] array, String value) {
        Arrays.sort(array);
        int i = 0;
        for(String str : array){
            if(str.contains(value)) {
                i++;
            }
        }

        return i;
    }

    /**
     * @param array         array of String objects
     * @param valueToRemove value to remove from array
     * @return array with identical contents excluding values of `value`
     */ // TODO
    public static String[] removeValue(String[] array, String valueToRemove) {
        String[] tempArr = new String[array.length];
        int i = 0;
        for (String str : array){
            if (!str.equals(valueToRemove)){
                tempArr[i] = str;
                i++;
            }
        }
        String[] array2 = Arrays.copyOf(tempArr,i);
        return array2;
    }

    /**
     * @param array array of chars
     * @return array of Strings with consecutive duplicates removes
     */ // TODO
    public static String[] removeConsecutiveDuplicates(String[] array) {
        String[] str = new String[array.length];
        String dup = "";
        int num = 0;
        for (int i = 0; i < array.length; i++) {
            if (!array[i].equals(dup)){
                dup = array[i];
                str[num] = array[i];
                num++;
            }

        }
        String[] strNew = Arrays.copyOf(str, num);
        return strNew;
    }

    /**
     * @param array array of chars
     * @return array of Strings with each consecutive duplicate occurrence concatenated as a single string in an array of Strings
     */ // TODO
    public static String[] packConsecutiveDuplicates(String[] array) {
        String[] str = new String[array.length];
        String dup = array[0];
        int num = 0;
        String conC = array[0];
        for (int i=1; i < array.length; i++) {
            if (!array[i].equals(dup)){
                dup = array[i];
                str[num] = conC;
                conC = array[i];
                num++;
            }
            else {

                conC += array[i];
            }


        }
        str[num] = conC;
        String[] strNew = Arrays.copyOf(str, num+1);
        return strNew;
    }


}
